Index: Makefile
===================================================================
RCS file: /home/ncvs/src/lib/msun/Makefile,v
retrieving revision 1.98
diff -u -r1.98 Makefile
--- Makefile	7 Aug 2008 15:07:48 -0000	1.98
+++ Makefile	12 Jan 2009 19:25:14 -0000
@@ -12,6 +12,8 @@
 #
 #
 
+CFLAGS+=	-finline-functions
+
 .if ${MACHINE_ARCH} == "i386"
 ARCH_SUBDIR= i387
 .else
Index: src/e_rem_pio2.c
===================================================================
RCS file: /home/ncvs/src/lib/msun/src/e_rem_pio2.c,v
retrieving revision 1.19
diff -u -r1.19 e_rem_pio2.c
--- src/e_rem_pio2.c	8 Aug 2008 00:21:27 -0000	1.19
+++ src/e_rem_pio2.c	12 Jan 2009 19:25:14 -0000
@@ -48,9 +48,6 @@
 pio2_3  =  2.02226624871116645580e-21, /* 0x3BA3198A, 0x2E000000 */
 pio2_3t =  8.47842766036889956997e-32; /* 0x397B839A, 0x252049C1 */
 
-#ifdef INLINE_REM_PIO2
-extern inline
-#endif
 int
 __ieee754_rem_pio2(double x, double *y)
 {
Index: src/e_rem_pio2f.c
===================================================================
RCS file: /home/ncvs/src/lib/msun/src/e_rem_pio2f.c,v
retrieving revision 1.30
diff -u -r1.30 e_rem_pio2f.c
--- src/e_rem_pio2f.c	8 Aug 2008 00:21:27 -0000	1.30
+++ src/e_rem_pio2f.c	12 Jan 2009 19:25:14 -0000
@@ -40,9 +40,6 @@
 pio2_1  =  1.57079631090164184570e+00, /* 0x3FF921FB, 0x50000000 */
 pio2_1t =  1.58932547735281966916e-08; /* 0x3E5110b4, 0x611A6263 */
 
-#ifdef INLINE_REM_PIO2F
-extern inline
-#endif
 int
 __ieee754_rem_pio2f(float x, double *y)
 {
Index: src/k_cosf.c
===================================================================
RCS file: /home/ncvs/src/lib/msun/src/k_cosf.c,v
retrieving revision 1.16
diff -u -r1.16 k_cosf.c
--- src/k_cosf.c	22 Feb 2008 02:30:35 -0000	1.16
+++ src/k_cosf.c	12 Jan 2009 19:25:14 -0000
@@ -14,10 +14,8 @@
  * ====================================================
  */
 
-#ifndef INLINE_KERNEL_COSDF
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD: src/lib/msun/src/k_cosf.c,v 1.16 2008/02/22 02:30:35 das Exp $");
-#endif
 
 #include "math.h"
 #include "math_private.h"
@@ -30,9 +28,6 @@
 C2  = -0x16c087e80f1e27.0p-62,	/* -0.00138867637746099294692 */
 C3  =  0x199342e0ee5069.0p-68;	/*  0.0000243904487962774090654 */
 
-#ifdef INLINE_KERNEL_COSDF
-extern inline
-#endif
 float
 __kernel_cosdf(double x)
 {
Index: src/k_sinf.c
===================================================================
RCS file: /home/ncvs/src/lib/msun/src/k_sinf.c,v
retrieving revision 1.14
diff -u -r1.14 k_sinf.c
--- src/k_sinf.c	22 Feb 2008 02:30:35 -0000	1.14
+++ src/k_sinf.c	12 Jan 2009 19:25:14 -0000
@@ -14,10 +14,8 @@
  * ====================================================
  */
 
-#ifndef INLINE_KERNEL_SINDF
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD: src/lib/msun/src/k_sinf.c,v 1.14 2008/02/22 02:30:35 das Exp $");
-#endif
 
 #include "math.h"
 #include "math_private.h"
@@ -29,9 +27,6 @@
 S3 = -0x1a00f9e2cae774.0p-65,	/* -0.000198393348360966317347 */
 S4 =  0x16cd878c3b46a7.0p-71;	/*  0.0000027183114939898219064 */
 
-#ifdef INLINE_KERNEL_SINDF
-extern inline
-#endif
 float
 __kernel_sindf(double x)
 {
Index: src/k_tanf.c
===================================================================
RCS file: /home/ncvs/src/lib/msun/src/k_tanf.c,v
retrieving revision 1.21
diff -u -r1.21 k_tanf.c
--- src/k_tanf.c	22 Feb 2008 02:30:35 -0000	1.21
+++ src/k_tanf.c	12 Jan 2009 19:25:14 -0000
@@ -13,10 +13,8 @@
  * ====================================================
  */
 
-#ifndef INLINE_KERNEL_TANDF
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD: src/lib/msun/src/k_tanf.c,v 1.21 2008/02/22 02:30:35 das Exp $");
-#endif
 
 #include "math.h"
 #include "math_private.h"
@@ -32,9 +30,6 @@
   0x1362b9bf971bcd.0p-59,	/* 0.00946564784943673166728 */
 };
 
-#ifdef INLINE_KERNEL_TANDF
-extern inline
-#endif
 float
 __kernel_tandf(double x, int iy)
 {
Index: src/s_cos.c
===================================================================
RCS file: /home/ncvs/src/lib/msun/src/s_cos.c,v
retrieving revision 1.12
diff -u -r1.12 s_cos.c
--- src/s_cos.c	18 Feb 2008 14:02:12 -0000	1.12
+++ src/s_cos.c	12 Jan 2009 19:25:14 -0000
@@ -47,9 +47,7 @@
 #include <float.h>
 
 #include "math.h"
-#define INLINE_REM_PIO2
 #include "math_private.h"
-#include "e_rem_pio2.c"
 
 double
 cos(double x)
Index: src/s_cosf.c
===================================================================
RCS file: /home/ncvs/src/lib/msun/src/s_cosf.c,v
retrieving revision 1.18
diff -u -r1.18 s_cosf.c
--- src/s_cosf.c	25 Feb 2008 22:19:17 -0000	1.18
+++ src/s_cosf.c	12 Jan 2009 19:25:14 -0000
@@ -20,13 +20,7 @@
 #include <float.h>
 
 #include "math.h"
-#define	INLINE_KERNEL_COSDF
-#define	INLINE_KERNEL_SINDF
-#define INLINE_REM_PIO2F
 #include "math_private.h"
-#include "e_rem_pio2f.c"
-#include "k_cosf.c"
-#include "k_sinf.c"
 
 /* Small multiples of pi/2 rounded to double precision. */
 static const double
Index: src/s_sin.c
===================================================================
RCS file: /home/ncvs/src/lib/msun/src/s_sin.c,v
retrieving revision 1.12
diff -u -r1.12 s_sin.c
--- src/s_sin.c	18 Feb 2008 14:02:12 -0000	1.12
+++ src/s_sin.c	12 Jan 2009 19:25:14 -0000
@@ -47,9 +47,7 @@
 #include <float.h>
 
 #include "math.h"
-#define INLINE_REM_PIO2
 #include "math_private.h"
-#include "e_rem_pio2.c"
 
 double
 sin(double x)
Index: src/s_sinf.c
===================================================================
RCS file: /home/ncvs/src/lib/msun/src/s_sinf.c,v
retrieving revision 1.17
diff -u -r1.17 s_sinf.c
--- src/s_sinf.c	25 Feb 2008 22:19:17 -0000	1.17
+++ src/s_sinf.c	12 Jan 2009 19:25:14 -0000
@@ -20,13 +20,7 @@
 #include <float.h>
 
 #include "math.h"
-#define	INLINE_KERNEL_COSDF
-#define	INLINE_KERNEL_SINDF
-#define INLINE_REM_PIO2F
 #include "math_private.h"
-#include "e_rem_pio2f.c"
-#include "k_cosf.c"
-#include "k_sinf.c"
 
 /* Small multiples of pi/2 rounded to double precision. */
 static const double
Index: src/s_tan.c
===================================================================
RCS file: /home/ncvs/src/lib/msun/src/s_tan.c,v
retrieving revision 1.12
diff -u -r1.12 s_tan.c
--- src/s_tan.c	18 Feb 2008 14:02:12 -0000	1.12
+++ src/s_tan.c	12 Jan 2009 19:25:14 -0000
@@ -46,9 +46,7 @@
 #include <float.h>
 
 #include "math.h"
-#define INLINE_REM_PIO2
 #include "math_private.h"
-#include "e_rem_pio2.c"
 
 double
 tan(double x)
Index: src/s_tanf.c
===================================================================
RCS file: /home/ncvs/src/lib/msun/src/s_tanf.c,v
retrieving revision 1.17
diff -u -r1.17 s_tanf.c
--- src/s_tanf.c	25 Feb 2008 22:19:17 -0000	1.17
+++ src/s_tanf.c	12 Jan 2009 19:25:14 -0000
@@ -20,11 +20,7 @@
 #include <float.h>
 
 #include "math.h"
-#define	INLINE_KERNEL_TANDF
-#define INLINE_REM_PIO2F
 #include "math_private.h"
-#include "e_rem_pio2f.c"
-#include "k_tanf.c"
 
 /* Small multiples of pi/2 rounded to double precision. */
 static const double