? cvsignore.5.gz
? cvsintro.7.gz
? cvsrc.5.gz
? cvswrappers.5.gz
? date.c
? opencvs
Index: Makefile
===================================================================
RCS file: /cvs/src/usr.bin/cvs/Makefile,v
retrieving revision 1.47
diff -u -r1.47 Makefile
--- Makefile	21 Jun 2008 15:39:15 -0000	1.47
+++ Makefile	17 Oct 2008 08:51:45 -0000
@@ -22,4 +22,7 @@
 
 INSTALL_STRIP=
 
+DPADD+= ${LIBZ}
+LDADD+= -lz -lmd
+
 .include <bsd.prog.mk>
Index: admin.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/admin.c,v
retrieving revision 1.64
diff -u -r1.64 admin.c
--- admin.c	12 Sep 2008 13:20:36 -0000	1.64
+++ admin.c	17 Oct 2008 08:51:45 -0000
@@ -24,6 +24,7 @@
 #include <fcntl.h>
 #include <libgen.h>
 #include <string.h>
+#include <time.h>
 #include <unistd.h>
 
 #include "cvs.h"
Index: atomicio.h
===================================================================
RCS file: /cvs/src/usr.bin/cvs/atomicio.h,v
retrieving revision 1.1
diff -u -r1.1 atomicio.h
--- atomicio.h	17 Sep 2007 10:07:21 -0000	1.1
+++ atomicio.h	17 Oct 2008 08:51:45 -0000
@@ -1,4 +1,4 @@
-/* $OpenBSD: atomicio.h,v 1.1 2007/09/17 10:07:21 tobias Exp $ */
+/* $OpenBSD: atomicio.h,v 1.10 2006/08/03 03:34:41 deraadt Exp $ */
 
 /*
  * Copyright (c) 2006 Damien Miller.  All rights reserved.
@@ -35,5 +35,11 @@
 size_t	atomicio(ssize_t (*)(int, void *, size_t), int, void *, size_t);
 
 #define vwrite (ssize_t (*)(int, void *, size_t))write
+
+/*
+ * ensure all of data on socket comes through. f==readv || f==writev
+ */
+size_t	atomiciov(ssize_t (*)(int, const struct iovec *, int),
+    int, const struct iovec *, int);
 
 #endif /* _ATOMICIO_H */
Index: checkout.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/checkout.c,v
retrieving revision 1.156
diff -u -r1.156 checkout.c
--- checkout.c	8 Jul 2008 12:29:58 -0000	1.156
+++ checkout.c	17 Oct 2008 08:51:45 -0000
@@ -352,6 +352,7 @@
 				xfree(module_repo_root);
 		}
 
+#define TAILQ_END(head)                 NULL
 		if (mc->mc_canfree == 1) {
 			for (fl = TAILQ_FIRST(&(mc->mc_modules));
 			    fl != TAILQ_END(&(mc->mc_modules)); fl = nxt) {
Index: cmd.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/cmd.c,v
retrieving revision 1.68
diff -u -r1.68 cmd.c
--- cmd.c	3 Feb 2008 18:18:44 -0000	1.68
+++ cmd.c	17 Oct 2008 08:51:45 -0000
@@ -27,6 +27,7 @@
 #include <sys/dirent.h>
 
 #include <string.h>
+#include <time.h>
 
 #include "cvs.h"
 
Index: config.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/config.c,v
retrieving revision 1.15
diff -u -r1.15 config.c
--- config.c	2 Mar 2008 11:58:45 -0000	1.15
+++ config.c	17 Oct 2008 08:51:45 -0000
@@ -23,6 +23,7 @@
 #include <limits.h>
 #include <stdlib.h>
 #include <string.h>
+#include <time.h>
 
 #include "cvs.h"
 #include "config.h"
Index: cvs.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/cvs.c,v
retrieving revision 1.150
diff -u -r1.150 cvs.c
--- cvs.c	21 Jun 2008 15:39:15 -0000	1.150
+++ cvs.c	17 Oct 2008 08:51:45 -0000
@@ -70,7 +70,7 @@
 struct cvs_cmd *cmdp;			/* struct of command we are running */
 
 int		cvs_getopt(int, char **);
-__dead void	usage(void);
+void	usage(void);
 static void	cvs_read_rcfile(void);
 
 struct cvs_wklhead temp_files;
@@ -122,7 +122,7 @@
 		cvs_ent_close(current_list, ENT_SYNC);
 }
 
-__dead void
+void
 usage(void)
 {
 	(void)fprintf(stderr,
Index: cvs.h
===================================================================
RCS file: /cvs/src/usr.bin/cvs/cvs.h,v
retrieving revision 1.172
diff -u -r1.172 cvs.h
--- cvs.h	27 Jun 2008 21:14:15 -0000	1.172
+++ cvs.h	17 Oct 2008 08:51:45 -0000
@@ -433,5 +433,6 @@
 int	cvs_watch(int, char **);
 int	cvs_watchers(int, char **);
 
+#define SIZE_MAX ULONG_MAX
 
 #endif
Index: date.y
===================================================================
RCS file: /cvs/src/usr.bin/cvs/date.y,v
retrieving revision 1.18
diff -u -r1.18 date.y
--- date.y	16 Feb 2008 01:00:00 -0000	1.18
+++ date.y	17 Oct 2008 08:51:45 -0000
@@ -14,6 +14,7 @@
 /* SUPPRESS 287 on yaccpar_sccsid *//* Unused static variable */
 /* SUPPRESS 288 on yyerrlab *//* Label unused */
 
+#include <time.h>
 #include <sys/timeb.h>
 
 #include <ctype.h>
Index: diff3.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/diff3.c,v
retrieving revision 1.48
diff -u -r1.48 diff3.c
--- diff3.c	9 Mar 2008 01:52:55 -0000	1.48
+++ diff3.c	17 Oct 2008 08:51:45 -0000
@@ -81,6 +81,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <time.h>
 #include <unistd.h>
 
 #include "atomicio.h"
Index: getlog.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/getlog.c,v
retrieving revision 1.90
diff -u -r1.90 getlog.c
--- getlog.c	12 Sep 2008 13:38:35 -0000	1.90
+++ getlog.c	17 Oct 2008 08:51:45 -0000
@@ -19,6 +19,7 @@
 #include <unistd.h>
 #include <string.h>
 #include <errno.h>
+#include <time.h>
 
 #include "cvs.h"
 #include "remote.h"
Index: hash.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/hash.c,v
retrieving revision 1.1
diff -u -r1.1 hash.c
--- hash.c	21 Jun 2008 15:39:15 -0000	1.1
+++ hash.c	17 Oct 2008 08:51:45 -0000
@@ -21,6 +21,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <time.h>
 
 #include "cvs.h"
 #include "hash.h"
Index: log.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/log.c,v
retrieving revision 1.45
diff -u -r1.45 log.c
--- log.c	12 Jun 2008 16:53:12 -0000	1.45
+++ log.c	17 Oct 2008 08:51:45 -0000
@@ -27,6 +27,7 @@
 
 #include <errno.h>
 #include <string.h>
+#include <time.h>
 
 #include "cvs.h"
 
Index: log.h
===================================================================
RCS file: /cvs/src/usr.bin/cvs/log.h,v
retrieving revision 1.23
diff -u -r1.23 log.h
--- log.h	10 Jun 2008 01:00:34 -0000	1.23
+++ log.h	17 Oct 2008 08:51:46 -0000
@@ -47,6 +47,6 @@
 void	cvs_vlog(u_int, const char *, va_list);
 int	cvs_printf(const char *, ...) __attribute__((format(printf, 1, 2)));
 int	cvs_vprintf(const char *, va_list);
-void	fatal(const char *, ...) __dead __attribute__((format(printf, 1,2)));
+void	fatal(const char *, ...) __attribute__((format(printf, 1,2)));
 
 #endif	/* LOG_H */
Index: modules.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/modules.c,v
retrieving revision 1.13
diff -u -r1.13 modules.c
--- modules.c	8 Mar 2008 21:58:34 -0000	1.13
+++ modules.c	17 Oct 2008 08:51:46 -0000
@@ -22,6 +22,7 @@
 #include <ctype.h>
 #include <stdlib.h>
 #include <string.h>
+#include <time.h>
 
 #include "cvs.h"
 #include "config.h"
Index: rcsnum.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/rcsnum.c,v
retrieving revision 1.53
diff -u -r1.53 rcsnum.c
--- rcsnum.c	22 May 2008 07:03:02 -0000	1.53
+++ rcsnum.c	17 Oct 2008 08:51:46 -0000
@@ -26,6 +26,7 @@
 
 #include <ctype.h>
 #include <string.h>
+#include <time.h>
 
 #include "cvs.h"
 
Index: remove.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/remove.c,v
retrieving revision 1.79
diff -u -r1.79 remove.c
--- remove.c	23 Jun 2008 20:51:08 -0000	1.79
+++ remove.c	17 Oct 2008 08:51:46 -0000
@@ -17,6 +17,7 @@
 
 #include <errno.h>
 #include <string.h>
+#include <time.h>
 #include <unistd.h>
 
 #include "cvs.h"
Index: root.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/root.c,v
retrieving revision 1.45
diff -u -r1.45 root.c
--- root.c	20 Jun 2008 23:00:13 -0000	1.45
+++ root.c	17 Oct 2008 08:51:46 -0000
@@ -27,6 +27,7 @@
 #include <errno.h>
 #include <stdlib.h>
 #include <string.h>
+#include <time.h>
 
 #include "cvs.h"
 
Index: tag.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/tag.c,v
retrieving revision 1.76
diff -u -r1.76 tag.c
--- tag.c	20 Jun 2008 14:04:29 -0000	1.76
+++ tag.c	17 Oct 2008 08:51:46 -0000
@@ -17,6 +17,7 @@
 
 #include <errno.h>
 #include <string.h>
+#include <time.h>
 #include <unistd.h>
 
 #include "cvs.h"
Index: trigger.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/trigger.c,v
retrieving revision 1.16
diff -u -r1.16 trigger.c
--- trigger.c	29 Aug 2008 09:51:21 -0000	1.16
+++ trigger.c	17 Oct 2008 08:51:46 -0000
@@ -27,6 +27,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <time.h>
 #include <unistd.h>
 
 #include "config.h"
Index: util.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/util.c,v
retrieving revision 1.147
diff -u -r1.147 util.c
--- util.c	21 Jun 2008 15:39:15 -0000	1.147
+++ util.c	17 Oct 2008 08:51:46 -0000
@@ -30,7 +30,7 @@
 #include <sys/types.h>
 #include <sys/wait.h>
 
-#include <atomicio.h>
+#include "atomicio.h"
 #include <errno.h>
 #include <fcntl.h>
 #include <md5.h>
Index: version.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/version.c,v
retrieving revision 1.25
diff -u -r1.25 version.c
--- version.c	2 May 2007 16:26:50 -0000	1.25
+++ version.c	17 Oct 2008 08:51:46 -0000
@@ -16,6 +16,8 @@
  * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
+#include <time.h>
+
 #include "cvs.h"
 #include "remote.h"
 
Index: watch.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/watch.c,v
retrieving revision 1.21
diff -u -r1.21 watch.c
--- watch.c	23 Jun 2008 20:51:08 -0000	1.21
+++ watch.c	17 Oct 2008 08:51:46 -0000
@@ -16,6 +16,7 @@
  */
 
 #include <string.h>
+#include <time.h>
 #include <unistd.h>
 
 #include "cvs.h"
Index: worklist.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/worklist.c,v
retrieving revision 1.6
diff -u -r1.6 worklist.c
--- worklist.c	22 Feb 2007 06:42:10 -0000	1.6
+++ worklist.c	17 Oct 2008 08:51:46 -0000
@@ -25,6 +25,7 @@
  */
 
 #include <string.h>
+#include <time.h>
 #include <unistd.h>
 
 #include "cvs.h"
Index: xmalloc.c
===================================================================
RCS file: /cvs/src/usr.bin/cvs/xmalloc.c,v
retrieving revision 1.8
diff -u -r1.8 xmalloc.c
--- xmalloc.c	22 Feb 2007 06:42:10 -0000	1.8
+++ xmalloc.c	17 Oct 2008 08:51:46 -0000
@@ -13,6 +13,8 @@
  * called by a name other than "ssh" or "Secure Shell".
  */
 
+#include <sys/types.h>
+
 #include <limits.h>
 #include <stdio.h>
 #include <stdlib.h>
Index: xmalloc.h
===================================================================
RCS file: /cvs/src/usr.bin/cvs/xmalloc.h,v
retrieving revision 1.3
diff -u -r1.3 xmalloc.h
--- xmalloc.h	29 Jan 2007 16:22:29 -0000	1.3
+++ xmalloc.h	17 Oct 2008 08:51:46 -0000
@@ -29,7 +29,6 @@
                 __attribute__((__nonnull__ (2)));
 int	 xsnprintf(char *, size_t, const char *, ...)
 		__attribute__((__format__ (printf, 3, 4)))
-		__attribute__((__nonnull__ (3)))
-		__attribute__((__bounded__ (__string__,1,2)));
+		__attribute__((__nonnull__ (3)));
 
 #endif	/* XMALLOC_H */